--[[
local infiniteOreName = "infinite-".. v.name

		if game.entity_prototypes[infiniteOreName] then
			entityList[infiniteOreName] = 1
		end
]]--


function globalPrint(msg)
  local players = game.players
  --if RanaMods.ModularArmor.config.Debug then
      for x=1, #players do
        game.players[x].print(msg)
      end
  --end
end

script.on_event(defines.events.on_chunk_generated, function(event)
	local distX = event.area.left_top.x
	local distY = event.area.left_top.y
--	local mult = 1 + (math.floor(math.sqrt((distX * distX) + (distY * distY))) / 3500)
--  Distance is only important in that ignore center, ignore for now.
	local entity = {}
	--local minz = 32
	--local maxz = 0
	for x=0, 31 do
      entity[x] = {}
    end
	
	local totalOre = 0
	local oreTiles = 0
	local average
	local peak = -1
	local trough = -1
	
	local xWeight = 0
	local yWeight = 0
	--local center
	
	for _,ore in pairs(event.surface.find_entities_filtered({area = {{event.area.left_top.x, event.area.left_top.y}, {event.area.right_bottom.x, event.area.right_bottom.y}}, type="resource"})) do
		local x = ore.position.x - distX - 0.5 -- 0.5 because its offset, so it goes from 0.5 to 15.5, which won't fit in a normal array.
		local y = ore.position.y - distY - 0.5
		
		--[[if (entity[x] == nil) then
			entity[x] = {}
		end]]--
		globalPrint(x .. " " ..y)
		if (ore.prototype.infinite_resource == false) then
			entity[x][y] = {entity = ore, name = ore.name, position = ore.position, amount = ore.amount}
			totalOre = totalOre + ore.amount
			oreTiles = oreTiles + 1
			if (peak ~= -1) then
				peak = math.max(ore.amount,peak) -- Highest Amount
			else
				peak = ore.amount
			end
			if (trough ~= -1) then
				trough = math.min(ore.amount,peak) -- Lowest Amount
			else
				trough = ore.amount
			end
		end
		--xWeight = xWeight + x*ore.amount
		--yWeight = yWeight + y*ore.amount
		
		
	end
	if oreTiles ~= 0 then
		
		average = totalOre / oreTiles
		--center = {x = (xWeight / totalOre), y = (yWeight / totalOre)} -- Weighted center.
		
		-- Threshhold
		
		local threshhold = trough + ((peak-trough)*0.8) -- Make const
		
		
		local first_player = game.players[1]
		first_player.print(average .. " " .. trough .. " " .. peak .. " " .. threshhold)
		
		-- Replace with table lookup
		--for _,ore in pairs(event.surface.find_entities_filtered({area = {{event.area.left_top.x, event.area.left_top.y}, {event.area.right_bottom.x, event.area.right_bottom.y}}, type="resource"})) do
		for x = 0, 31, 1 do
			for y = 0, 31, 1 do
				local ore = entity[x][y]
				if ore ~= nil then
					x = ore.position.x - distX - 0.5
					y = ore.position.y - distY - 0.5
					--x = ore.position.x - distX - 0.5 - center.x
					--y = ore.position.y - distY - 0.5 - center.y
					--local distance = (math.floor(math.sqrt((x * x) + (y * y))))
					-- Tile distance from center.
					--local mult = 1
					if (ore.amount > threshhold) then
						ore.entity.destroy()
						ore = event.surface.create_entity{name = "infinite-"..(ore.name),position = entity[x][y].position,amount = entity[x][y].amount}
						--mult = 1000
						-- Convert to Infintie.
						
					end
				end
				--ore.amount = ore.amount * mult
			end
		end
	
	else
		-- No ore here.
	end
	
end)

--[[
script.on_event(defines.events.on_chunk_generated, function(event)
	local distX = math.abs(event.area.left_top.x)
	local distY = math.abs(event.area.left_top.y)
	local mult = 1 + (math.floor(math.sqrt((distX * distX) + (distY * distY))) / 3500)
	
	if mult > 1 then
		for _,ore in pairs(event.surface.find_entities_filtered({area = {{event.area.left_top.x, event.area.left_top.y}, {event.area.right_bottom.x, event.area.right_bottom.y}}, type="resource"})) do
			ore.amount = math.floor(ore.amount * mult)
		end
	end
end)]]--

--[[
Ok, On Chunk Generation
Map entire ore patch.
If you ever hit edge of the chunk, drop it.
Once a new chunk is generated you can manage that as well.



Build a 2d array, one entry per tile in a chunk

---
Simple first

Ignore chunk borders.

Make an array of all tiles in chunk with a said type of ore in it. Initially ignore infinite part, just make it 10x as much if valid.

Get total ore count.
Get Averate Ore count.
Set all ore to Average.

]]--

--[[


]]--